const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let today = new Date();

    let lastMonthFrom = new Date(today);
    lastMonthFrom.setMonth(today.getMonth() - 1, 1);
    Mesa.log.info("last month from month: " + lastMonthFrom.getMonth());
    if (lastMonthFrom.getMonth() + 1 == 11) {
      lastMonthFrom.setMonth(today.getMonth() - 2, 1);  
    }

    let lastMonthTo = new Date(today);
    lastMonthTo.setMonth(today.getMonth() - 1);
    if (lastMonthTo.getMonth() + 1 == 11) {
      lastMonthTo.setMonth(today.getMonth() - 2);  
    }

    let thisMonthFrom = new Date(today);
    thisMonthFrom.setMonth(today.getMonth(), 1);

    let thisMonthTo = new Date(today);

    let data = {
      "last_month_from": lastMonthFrom.toISOString().slice(0, 10),    
      "last_month_to": lastMonthTo.toISOString().slice(0, 10),
      "this_month_from": thisMonthFrom.toISOString().slice(0, 10),    
      "this_month_to": today.toISOString().slice(0, 10),    
    };

    Mesa.trigger.setTaskExternalData({
      "label": JSON.stringify(data),
    })

    // We're done, call the next step!
    Mesa.output.next(data);
  }
}
