const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let lastMonth = vars.data[0].sum;
    let thisMonth = vars.data_1[0].sum;

    let percent = 0;
    if (thisMonth > lastMonth) {
      percent = Math.round((1 - (lastMonth / thisMonth)) * 100); 
    } else {
      percent = Math.round((1 - (thisMonth / lastMonth)) * 100); 
    }

    let data = {
      "percent": percent,
      "last_month": Math.round(lastMonth).toLocaleString(),
      "this_month": Math.round(thisMonth).toLocaleString(),
    }

    Mesa.trigger.setTaskExternalData({
      "label": JSON.stringify(data)
    })

    Mesa.output.next(data);
  }
}
